/* A Bison parser, made by GNU Bison 3.0.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 24 "../../smtpd/parse.y" /* yacc.c:339  */

#include "includes.h"

#include <sys/types.h>
#include <sys/time.h>
#include <sys/queue.h>
#include <sys/tree.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/ioctl.h>

#include <net/if.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <ctype.h>
#include <err.h>
#include <errno.h>
#include <event.h>
#include <ifaddrs.h>
#include <imsg.h>
#include <inttypes.h>
#include <limits.h>
#include <netdb.h>
#include <pwd.h>
#include <stdarg.h>
#include <resolv.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <syslog.h>
#include <unistd.h>
#ifdef HAVE_UTIL_H
#include <util.h>
#endif

#include <openssl/ssl.h>

#include "smtpd.h"
#include "ssl.h"
#include "log.h"

TAILQ_HEAD(files, file)		 files = TAILQ_HEAD_INITIALIZER(files);
static struct file {
	TAILQ_ENTRY(file)	 entry;
	FILE			*stream;
	char			*name;
	size_t			 ungetpos;
	size_t			 ungetsize;
	u_char			*ungetbuf;
	int			 eof_reached;
	int			 lineno;
	int			 errors;
} *file, *topfile;
struct file	*pushfile(const char *, int);
int		 popfile(void);
int		 check_file_secrecy(int, const char *);
int		 yyparse(void);
int		 yylex(void);
int		 kw_cmp(const void *, const void *);
int		 lookup(char *);
int		 igetc(void);
int		 lgetc(int);
void		 lungetc(int);
int		 findeol(void);
int		 yyerror(const char *, ...)
    __attribute__((__format__ (printf, 1, 2)))
    __attribute__((__nonnull__ (1)));

TAILQ_HEAD(symhead, sym)	 symhead = TAILQ_HEAD_INITIALIZER(symhead);
struct sym {
	TAILQ_ENTRY(sym)	 entry;
	int			 used;
	int			 persist;
	char			*nam;
	char			*val;
};
int		 symset(const char *, const char *, int);
char		*symget(const char *);

struct smtpd		*conf = NULL;
static int		 errors = 0;

struct table		*table = NULL;
struct mta_limits	*limits;
static struct pki	*pki;
static struct ca	*sca;

struct dispatcher	*dispatcher;
struct rule		*rule;


enum listen_options {
	LO_FAMILY	= 0x000001,
	LO_PORT		= 0x000002,
	LO_SSL		= 0x000004,
	LO_FILTER      	= 0x000008,
	LO_PKI      	= 0x000010,
	LO_AUTH      	= 0x000020,
	LO_TAG      	= 0x000040,
	LO_HOSTNAME   	= 0x000080,
	LO_HOSTNAMES   	= 0x000100,
	LO_MASKSOURCE  	= 0x000200,
	LO_NODSN	= 0x000400,
	LO_SENDERS	= 0x000800,
	LO_RECEIVEDAUTH = 0x001000,
	LO_MASQUERADE	= 0x002000,
	LO_CA		= 0x010000
};

static struct listen_opts {
	char	       *ifx;
	int		family;
	in_port_t	port;
	uint16_t	ssl;
	char	       *filtername;
	char	       *pki;
	char	       *ca;
	uint16_t       	auth;
	struct table   *authtable;
	char	       *tag;
	char	       *hostname;
	struct table   *hostnametable;
	struct table   *sendertable;
	uint16_t	flags;

	uint32_t       	options;
} listen_opts;

static void	create_sock_listener(struct listen_opts *);
static void	create_if_listener(struct listen_opts *);
static void	config_listener(struct listener *, struct listen_opts *);
static int	host_v4(struct listen_opts *);
static int	host_v6(struct listen_opts *);
static int	host_dns(struct listen_opts *);
static int	interface(struct listen_opts *);

int		 delaytonum(char *);
int		 is_if_in_group(const char *, const char *);

static int config_lo_filter(struct listen_opts *, char *);
static int config_lo_mask_source(struct listen_opts *);

typedef struct {
	union {
		int64_t		 number;
		struct table	*table;
		char		*string;
		struct host	*host;
		struct mailaddr	*maddr;
	} v;
	int lineno;
} YYSTYPE;


#line 222 "../../smtpd/parse.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    ACTION = 258,
    ALIAS = 259,
    ANY = 260,
    ARROW = 261,
    AUTH = 262,
    AUTH_OPTIONAL = 263,
    BACKUP = 264,
    BOUNCE = 265,
    CA = 266,
    CERT = 267,
    CIPHERS = 268,
    COMPRESSION = 269,
    DHE = 270,
    DOMAIN = 271,
    ENCRYPTION = 272,
    ERROR = 273,
    EXPAND_ONLY = 274,
    FILTER = 275,
    FOR = 276,
    FORWARD_ONLY = 277,
    FROM = 278,
    HELO = 279,
    HELO_SRC = 280,
    HOST = 281,
    HOSTNAME = 282,
    HOSTNAMES = 283,
    INCLUDE = 284,
    INET4 = 285,
    INET6 = 286,
    JUNK = 287,
    KEY = 288,
    LIMIT = 289,
    LISTEN = 290,
    LMTP = 291,
    LOCAL = 292,
    MAIL_FROM = 293,
    MAILDIR = 294,
    MASK_SRC = 295,
    MASQUERADE = 296,
    MATCH = 297,
    MAX_MESSAGE_SIZE = 298,
    MAX_DEFERRED = 299,
    MBOX = 300,
    MDA = 301,
    MTA = 302,
    MX = 303,
    NO_DSN = 304,
    NO_VERIFY = 305,
    ON = 306,
    PKI = 307,
    PORT = 308,
    QUEUE = 309,
    RCPT_TO = 310,
    RECIPIENT = 311,
    RECEIVEDAUTH = 312,
    RELAY = 313,
    REJECT = 314,
    SCHEDULER = 315,
    SENDER = 316,
    SENDERS = 317,
    SMTP = 318,
    SMTPS = 319,
    SOCKET = 320,
    SRC = 321,
    SUB_ADDR_DELIM = 322,
    TABLE = 323,
    TAG = 324,
    TAGGED = 325,
    TLS = 326,
    TLS_REQUIRE = 327,
    TO = 328,
    TTL = 329,
    USER = 330,
    USERBASE = 331,
    VERIFY = 332,
    VIRTUAL = 333,
    WARN_INTERVAL = 334,
    WRAPPER = 335,
    STRING = 336,
    NUMBER = 337
  };
#endif
/* Tokens.  */
#define ACTION 258
#define ALIAS 259
#define ANY 260
#define ARROW 261
#define AUTH 262
#define AUTH_OPTIONAL 263
#define BACKUP 264
#define BOUNCE 265
#define CA 266
#define CERT 267
#define CIPHERS 268
#define COMPRESSION 269
#define DHE 270
#define DOMAIN 271
#define ENCRYPTION 272
#define ERROR 273
#define EXPAND_ONLY 274
#define FILTER 275
#define FOR 276
#define FORWARD_ONLY 277
#define FROM 278
#define HELO 279
#define HELO_SRC 280
#define HOST 281
#define HOSTNAME 282
#define HOSTNAMES 283
#define INCLUDE 284
#define INET4 285
#define INET6 286
#define JUNK 287
#define KEY 288
#define LIMIT 289
#define LISTEN 290
#define LMTP 291
#define LOCAL 292
#define MAIL_FROM 293
#define MAILDIR 294
#define MASK_SRC 295
#define MASQUERADE 296
#define MATCH 297
#define MAX_MESSAGE_SIZE 298
#define MAX_DEFERRED 299
#define MBOX 300
#define MDA 301
#define MTA 302
#define MX 303
#define NO_DSN 304
#define NO_VERIFY 305
#define ON 306
#define PKI 307
#define PORT 308
#define QUEUE 309
#define RCPT_TO 310
#define RECIPIENT 311
#define RECEIVEDAUTH 312
#define RELAY 313
#define REJECT 314
#define SCHEDULER 315
#define SENDER 316
#define SENDERS 317
#define SMTP 318
#define SMTPS 319
#define SOCKET 320
#define SRC 321
#define SUB_ADDR_DELIM 322
#define TABLE 323
#define TAG 324
#define TAGGED 325
#define TLS 326
#define TLS_REQUIRE 327
#define TO 328
#define TTL 329
#define USER 330
#define USERBASE 331
#define VERIFY 332
#define VIRTUAL 333
#define WARN_INTERVAL 334
#define WRAPPER 335
#define STRING 336
#define NUMBER 337

/* Value type.  */


extern YYSTYPE yylval;

int yyparse (void);



/* Copy the second part of user declarations.  */

#line 429 "../../smtpd/parse.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   244

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  91
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  84
/* YYNRULES -- Number of rules.  */
#define YYNRULES  201
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  322

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   337

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      83,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    86,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    85,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      89,    84,    90,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    87,     2,    88,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   210,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   229,
     244,   262,   263,   264,   267,   268,   271,   274,   275,   278,
     278,   281,   289,   290,   293,   300,   301,   304,   305,   309,
     309,   316,   316,   340,   346,   351,   352,   363,   366,   366,
     378,   378,   385,   385,   408,   411,   414,   432,   433,   438,
     441,   444,   453,   466,   471,   472,   475,   478,   495,   518,
     539,   560,   576,   586,   587,   591,   591,   596,   596,   599,
     599,   602,   602,   610,   610,   618,   618,   622,   622,   626,
     626,   630,   630,   633,   633,   640,   648,   663,   671,   679,
     695,   703,   716,   728,   748,   756,   765,   789,   790,   794,
     798,   801,   807,   824,   825,   829,   829,   845,   862,   879,
     886,   893,   910,   927,   945,   953,   963,   973,   991,  1001,
    1011,  1031,  1032,  1036,  1046,  1049,  1053,  1053,  1069,  1076,
    1089,  1109,  1110,  1113,  1138,  1139,  1142,  1158,  1159,  1162,
    1165,  1168,  1178,  1179,  1182,  1204,  1205,  1209,  1214,  1221,
    1229,  1237,  1255,  1268,  1273,  1281,  1289,  1297,  1305,  1313,
    1321,  1329,  1337,  1345,  1354,  1363,  1377,  1386,  1402,  1407,
    1415,  1423,  1439,  1457,  1458,  1461,  1470,  1476,  1477,  1480,
    1481,  1485,  1485,  1492,  1530,  1530,  1538,  1547,  1547,  1555,
    1568,  1569
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ACTION", "ALIAS", "ANY", "ARROW",
  "AUTH", "AUTH_OPTIONAL", "BACKUP", "BOUNCE", "CA", "CERT", "CIPHERS",
  "COMPRESSION", "DHE", "DOMAIN", "ENCRYPTION", "ERROR", "EXPAND_ONLY",
  "FILTER", "FOR", "FORWARD_ONLY", "FROM", "HELO", "HELO_SRC", "HOST",
  "HOSTNAME", "HOSTNAMES", "INCLUDE", "INET4", "INET6", "JUNK", "KEY",
  "LIMIT", "LISTEN", "LMTP", "LOCAL", "MAIL_FROM", "MAILDIR", "MASK_SRC",
  "MASQUERADE", "MATCH", "MAX_MESSAGE_SIZE", "MAX_DEFERRED", "MBOX", "MDA",
  "MTA", "MX", "NO_DSN", "NO_VERIFY", "ON", "PKI", "PORT", "QUEUE",
  "RCPT_TO", "RECIPIENT", "RECEIVEDAUTH", "RELAY", "REJECT", "SCHEDULER",
  "SENDER", "SENDERS", "SMTP", "SMTPS", "SOCKET", "SRC", "SUB_ADDR_DELIM",
  "TABLE", "TAG", "TAGGED", "TLS", "TLS_REQUIRE", "TO", "TTL", "USER",
  "USERBASE", "VERIFY", "VIRTUAL", "WARN_INTERVAL", "WRAPPER", "STRING",
  "NUMBER", "'\\n'", "'='", "','", "'!'", "'{'", "'}'", "'<'", "'>'",
  "$accept", "grammar", "include", "varset", "comma", "optnl", "nl",
  "negation", "assign", "keyval", "keyval_list", "stringel", "string_list",
  "tableval_list", "bounce", "$@1", "ca", "$@2", "ca_params_opt",
  "ca_params", "mda", "mta", "$@3", "$@4", "pki", "$@5", "pki_params_opt",
  "pki_params", "queue", "scheduler", "smtp", "dispatcher_local_option",
  "dispatcher_local_options", "dispatcher_local", "$@6", "$@7", "$@8",
  "$@9", "$@10", "$@11", "$@12", "$@13", "$@14", "$@15",
  "dispatcher_remote_option", "dispatcher_remote_options",
  "dispatcher_remote", "dispatcher_type", "dispatcher_option",
  "dispatcher_options", "dispatcher", "$@16", "match_option",
  "match_options", "match_dispatcher", "action", "match", "$@17", "size",
  "bouncedelay", "bouncedelays", "opt_limit_mda", "limits_smtp",
  "opt_limit_smtp", "limits_mda", "opt_limit_mta", "limits_mta",
  "opt_limit_scheduler", "limits_scheduler", "opt_sock_listen",
  "opt_if_listen", "listener_type", "socket_listener", "if_listener",
  "sock_listen", "if_listen", "listen", "$@18", "table", "$@19",
  "tablenew", "$@20", "tableref", "tables", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,    10,    61,    44,    33,   123,   125,    60,
      62
};
# endif

#define YYPACT_NINF -155

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-155)))

#define YYTABLE_NINF -133

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -155,    20,  -155,   -66,   -53,   -42,   -40,   -37,  -155,  -155,
     -10,    -5,   -35,    -3,    27,    -7,   -24,   -11,  -155,    -2,
       1,     4,    11,    16,    21,    24,    28,    30,    31,    32,
      34,    40,    42,  -155,  -155,  -155,  -155,  -155,    54,     0,
      25,    29,    61,    44,  -155,  -155,    49,    52,    58,    66,
      71,   -29,    79,    80,    83,  -155,  -155,  -155,  -155,  -155,
    -155,  -155,  -155,  -155,  -155,  -155,  -155,  -155,  -155,   140,
      85,   123,   -49,  -155,   113,     0,    -1,    89,    25,  -155,
      86,   158,   -18,  -155,    23,  -155,  -155,    93,    58,  -155,
    -155,    95,  -155,    71,  -155,  -155,  -155,  -155,  -155,    91,
    -155,  -155,  -155,    99,   -13,  -155,   100,   131,  -155,  -155,
     114,  -155,  -155,   102,   108,  -155,  -155,     5,   101,  -155,
    -155,  -155,   -47,    17,    13,   -47,   -47,   -47,   -47,  -155,
    -155,   109,  -155,  -155,  -155,  -155,  -155,   110,  -155,  -155,
     111,   -18,  -155,   115,   118,   119,    23,  -155,  -155,  -155,
    -155,  -155,   120,    22,    22,   137,  -155,   162,    22,    22,
    -155,   -47,   147,   122,   124,   -47,   -47,   125,   126,   -47,
     154,   131,  -155,   127,   114,  -155,    85,  -155,   128,  -155,
       5,  -155,   -47,   -47,   129,   130,   132,   -47,  -155,  -155,
    -155,  -155,   133,    -6,  -155,   -47,   135,   134,  -155,   139,
     101,  -155,  -155,  -155,   136,  -155,  -155,  -155,  -155,   -47,
    -155,  -155,  -155,  -155,   -47,  -155,  -155,  -155,  -155,  -155,
    -155,  -155,  -155,  -155,  -155,  -155,  -155,  -155,     9,    39,
    -155,    60,  -155,   138,   -47,   141,   -47,   -47,   142,    22,
    -155,  -155,  -155,    22,    22,  -155,    22,  -155,  -155,    22,
    -155,   143,  -155,  -155,  -155,  -155,  -155,  -155,  -155,  -155,
    -155,  -155,  -155,  -155,  -155,  -155,  -155,  -155,  -155,  -155,
    -155,  -155,  -155,  -155,  -155,   177,  -155,  -155,  -155,  -155,
     120,   144,  -155,  -155,   -18,  -155,  -155,   146,   145,  -155,
     148,  -155,   149,  -155,  -155,  -155,  -155,  -155,  -155,  -155,
      22,  -155,  -155,    22,  -155,  -155,  -155,  -155,   150,  -155,
    -155,  -155,   145,  -155,     9,  -155,  -155,  -155,  -155,  -155,
    -155,  -155
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     1,     0,     0,     0,     0,     0,   191,   136,
       0,     0,     0,     0,     0,     0,     0,     0,     3,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    18,   115,    39,    41,    19,     0,    28,
     148,     0,    50,     0,    52,    59,    60,     0,   156,     0,
     145,     0,     0,   194,     0,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    16,    17,    14,    15,     0,
       0,     0,     0,    27,     0,    28,     0,     0,   148,    45,
       0,     0,   153,    47,    58,    61,    62,     0,   156,    63,
      65,     0,    64,   145,   139,   138,    66,    67,   193,     0,
      20,    93,    91,     0,    77,    75,     0,   108,   110,   111,
     114,   140,   142,    40,     0,    44,    42,   188,   190,   192,
     183,   184,   120,     0,     0,     0,     0,     0,     0,   119,
     131,     0,   134,   137,   143,   147,    46,     0,   149,   150,
       0,   153,    51,     0,     0,     0,    58,    53,   154,   155,
     146,   144,     0,    74,    74,    85,    79,    81,    74,    74,
      89,     0,   102,     0,     0,     0,     0,     0,     0,     0,
     104,   108,   109,     0,   114,   116,     0,    43,     0,   158,
     188,   185,   171,   172,     0,     0,     0,     0,   159,   160,
     178,   180,     0,     0,   179,     0,   164,     0,   166,   167,
     190,   186,   196,   197,     0,   200,   201,   121,   129,     0,
     128,   126,   125,   124,     0,   118,   122,   123,   117,   133,
     135,    48,   151,   152,    54,    56,    55,    57,    34,    23,
      38,    23,    37,     0,     0,     0,     0,     0,     0,    74,
      94,    92,    87,    74,    74,    83,    74,    78,    76,    74,
     106,     0,    98,    95,    96,   103,   100,    97,    99,   105,
     107,   112,   113,   141,   157,   187,   173,   174,   170,   163,
     176,   177,   169,   161,   162,   181,   165,   175,   168,   189,
       0,     0,   130,   127,   153,    30,    29,     0,    25,    21,
       0,    22,     0,   195,    69,    68,    71,    70,    72,    73,
      74,    86,    80,    74,    82,    90,   101,   182,     0,   199,
      49,    31,    25,    26,     0,    33,    34,    36,    88,    84,
     198,    24
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -155,  -155,  -155,  -155,   -12,   -92,  -155,  -155,  -155,  -155,
     -69,  -155,   -67,   -48,  -155,  -155,  -155,  -155,  -155,  -155,
    -155,  -155,  -155,  -155,  -155,  -155,  -155,    87,  -155,  -155,
    -155,  -155,  -154,  -155,  -155,  -155,  -155,  -155,  -155,  -155,
    -155,  -155,  -155,  -155,  -155,    64,  -155,  -155,  -155,    57,
    -155,  -155,  -155,   161,  -155,  -155,  -155,  -155,  -155,    63,
    -155,  -155,   151,  -155,   159,  -155,  -140,  -155,   152,  -155,
    -155,  -155,  -155,  -155,    62,    41,  -155,  -155,  -155,  -155,
    -155,  -155,  -155,  -118
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    19,    20,   290,   313,   291,    74,   287,   229,
     230,   231,   232,   233,    21,    70,    22,    71,   115,   116,
      23,    24,   284,    82,    25,    84,   146,   147,    26,    27,
      28,   239,   240,   108,   159,   158,   244,   246,   303,   243,
     300,   249,   154,   153,   171,   172,   109,   110,   174,   175,
      29,    69,    75,    76,   220,   133,    30,    39,    96,   112,
     113,    78,    92,    93,    79,   141,   142,    88,    89,   180,
     200,   119,   120,   121,   181,   201,    31,    38,    32,    99,
     205,   280,   206,   207
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     241,   223,   131,  -132,   247,   248,    49,   215,   216,   217,
     218,    45,   138,   139,    46,   285,   117,    33,   211,   156,
       2,     3,   208,     4,    40,   178,   234,    50,    34,    42,
       5,     6,   118,   209,   202,   143,    51,    35,   144,    43,
     203,    36,   204,   250,    37,   179,    44,   254,   255,     7,
     212,   258,    94,    95,   210,     8,   145,    53,   132,  -132,
      52,    48,     9,   140,   266,   267,    10,    11,   157,   271,
      41,    47,    12,    54,    13,   273,   274,   275,   213,   214,
      14,    55,    81,    15,    56,   299,    73,    57,    16,   301,
     302,   282,   304,   286,    58,   305,   283,   235,   236,    59,
     237,    17,   238,    18,    60,    72,    77,    61,   182,   183,
      80,    62,   184,    63,    64,    65,   294,    66,   296,   297,
     122,   185,   288,    67,   289,    68,    83,   -32,   186,   187,
      85,   188,   189,    86,   123,   114,   124,   125,   161,    87,
     162,   190,   163,   288,   310,   289,   318,    90,   -35,   319,
     191,   126,    91,   192,   193,   164,   165,   166,   194,   101,
      97,    98,   102,   195,   100,   196,   111,   136,   127,   167,
     197,   134,   198,   199,   137,   148,   103,   150,   152,   104,
     155,   160,   128,   168,   129,   105,   106,   176,   173,   177,
     219,   221,   242,   222,   245,   251,   224,   169,   107,   225,
     226,   228,   170,   252,   259,   253,   256,   257,   261,   264,
     268,   269,   276,   270,   272,   277,   278,   281,   307,   292,
     321,   315,   295,   298,   306,   317,   293,   311,   312,   314,
     316,   262,   308,   227,   309,   260,   130,   135,   320,   263,
     149,   279,   265,     0,   151
};

static const yytype_int16 yycheck[] =
{
     154,   141,     3,     3,   158,   159,    13,   125,   126,   127,
     128,    14,    30,    31,    17,     6,    65,    83,     5,    32,
       0,     1,     5,     3,    34,    20,     4,    34,    81,    34,
      10,    11,    81,    16,    81,    12,    43,    79,    15,    44,
      87,    81,    89,   161,    81,    40,    81,   165,   166,    29,
      37,   169,    81,    82,    37,    35,    33,    81,    59,    59,
      67,    34,    42,    81,   182,   183,    46,    47,    81,   187,
      80,    74,    52,    84,    54,    81,    82,   195,    65,    66,
      60,    83,    21,    63,    83,   239,    86,    83,    68,   243,
     244,   209,   246,    84,    83,   249,   214,    75,    76,    83,
      78,    81,    80,    83,    83,    51,    81,    83,     7,     8,
      81,    83,    11,    83,    83,    83,   234,    83,   236,   237,
       7,    20,    83,    83,    85,    83,    82,    88,    27,    28,
      81,    30,    31,    81,    21,    12,    23,    24,     7,    81,
       9,    40,    11,    83,   284,    85,   300,    81,    88,   303,
      49,    38,    81,    52,    53,    24,    25,    26,    57,    19,
      81,    81,    22,    62,    81,    64,    81,    81,    55,    38,
      69,    82,    71,    72,    16,    82,    36,    82,    87,    39,
      81,    81,    69,    52,    71,    45,    46,    85,    74,    81,
      81,    81,    55,    82,    32,    48,    81,    66,    58,    81,
      81,    81,    71,    81,    50,    81,    81,    81,    81,    81,
      81,    81,    77,    81,    81,    81,    77,    81,    41,   231,
     312,   290,    81,    81,    81,   292,    88,    81,    83,    81,
      81,   174,   280,   146,    90,   171,    75,    78,    88,   176,
      88,   200,   180,    -1,    93
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    92,     0,     1,     3,    10,    11,    29,    35,    42,
      46,    47,    52,    54,    60,    63,    68,    81,    83,    93,
      94,   105,   107,   111,   112,   115,   119,   120,   121,   141,
     147,   167,   169,    83,    81,    79,    81,    81,   168,   148,
      34,    80,    34,    44,    81,    14,    17,    74,    34,    13,
      34,    43,    67,    81,    84,    83,    83,    83,    83,    83,
      83,    83,    83,    83,    83,    83,    83,    83,    83,   142,
     106,   108,    51,    86,    98,   143,   144,    81,   152,   155,
      81,    21,   114,    82,   116,    81,    81,    81,   158,   159,
      81,    81,   153,   154,    81,    82,   149,    81,    81,   170,
      81,    19,    22,    36,    39,    45,    46,    58,   124,   137,
     138,    81,   150,   151,    12,   109,   110,    65,    81,   162,
     163,   164,     7,    21,    23,    24,    38,    55,    69,    71,
     144,     3,    59,   146,    82,   155,    81,    16,    30,    31,
      81,   156,   157,    12,    15,    33,   117,   118,    82,   159,
      82,   153,    87,   134,   133,    81,    32,    81,   126,   125,
      81,     7,     9,    11,    24,    25,    26,    38,    52,    66,
      71,   135,   136,    74,   139,   140,    85,    81,    20,    40,
     160,   165,     7,     8,    11,    20,    27,    28,    30,    31,
      40,    49,    52,    53,    57,    62,    64,    69,    71,    72,
     161,   166,    81,    87,    89,   171,   173,   174,     5,    16,
      37,     5,    37,    65,    66,   174,   174,   174,   174,    81,
     145,    81,    82,   157,    81,    81,    81,   118,    81,   100,
     101,   102,   103,   104,     4,    75,    76,    78,    80,   122,
     123,   123,    55,   130,   127,    32,   128,   123,   123,   132,
     174,    48,    81,    81,   174,   174,    81,    81,   174,    50,
     136,    81,   140,   150,    81,   165,   174,   174,    81,    81,
      81,   174,    81,    81,    82,   174,    77,    81,    77,   166,
     172,    81,   174,   174,   113,     6,    84,    99,    83,    85,
      95,    97,    95,    88,   174,    81,   174,   174,    81,   123,
     131,   123,   123,   129,   123,   123,    81,    41,   104,    90,
     157,    81,    83,    96,    81,   101,    81,   103,   123,   123,
      88,    96
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    91,    92,    92,    92,    92,    92,    92,    92,    92,
      92,    92,    92,    92,    92,    92,    92,    92,    92,    93,
      94,    95,    95,    95,    96,    96,    97,    98,    98,    99,
      99,   100,   101,   101,   102,   103,   103,   104,   104,   106,
     105,   108,   107,   109,   110,   111,   111,   112,   113,   112,
     114,   112,   116,   115,   117,   117,   117,   118,   118,   119,
     119,   119,   119,   120,   121,   121,   121,   121,   122,   122,
     122,   122,   122,   123,   123,   125,   124,   126,   124,   127,
     124,   128,   124,   129,   124,   130,   124,   131,   124,   132,
     124,   133,   124,   134,   124,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   135,   136,   136,   137,
     138,   138,   139,   140,   140,   142,   141,   143,   143,   143,
     143,   143,   143,   143,   143,   143,   143,   143,   143,   143,
     143,   144,   144,   145,   146,   146,   148,   147,   149,   149,
     150,   151,   151,   152,   153,   153,   154,   155,   155,   156,
     156,   156,   157,   157,   158,   159,   159,   160,   160,   161,
     161,   161,   161,   161,   161,   161,   161,   161,   161,   161,
     161,   161,   161,   161,   161,   161,   161,   161,   161,   161,
     161,   161,   161,   162,   162,   163,   164,   165,   165,   166,
     166,   168,   167,   169,   170,   169,   171,   172,   171,   173,
     174,   174
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       3,     1,     1,     0,     2,     0,     2,     1,     0,     1,
       1,     3,     1,     3,     1,     1,     3,     1,     1,     0,
       4,     0,     4,     2,     1,     3,     4,     3,     0,     7,
       0,     4,     0,     4,     2,     2,     2,     2,     0,     2,
       2,     3,     3,     3,     3,     3,     3,     3,     2,     2,
       2,     2,     2,     2,     0,     0,     3,     0,     3,     0,
       4,     0,     4,     0,     5,     0,     4,     0,     5,     0,
       4,     0,     3,     0,     3,     2,     2,     2,     2,     2,
       2,     3,     1,     2,     1,     2,     2,     2,     0,     2,
       1,     1,     2,     2,     0,     0,     5,     3,     3,     2,
       2,     3,     3,     3,     3,     3,     3,     4,     3,     3,
       4,     2,     0,     1,     1,     2,     0,     4,     1,     1,
       1,     3,     1,     2,     2,     0,     2,     2,     0,     1,
       1,     2,     2,     0,     2,     2,     0,     2,     1,     1,
       1,     2,     2,     2,     1,     2,     1,     1,     2,     2,
       2,     1,     1,     2,     2,     2,     2,     2,     1,     1,
       1,     2,     3,     1,     1,     2,     2,     2,     0,     2,
       0,     0,     4,     3,     0,     6,     1,     0,     4,     3,
       1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 18:
#line 226 "../../smtpd/parse.y" /* yacc.c:1648  */
    { file->errors++; }
#line 1760 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 19:
#line 229 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			struct file	*nfile;

			if ((nfile = pushfile((yyvsp[0].v.string), 0)) == NULL) {
				yyerror("failed to include file %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			free((yyvsp[0].v.string));

			file = nfile;
			lungetc('\n');
		}
#line 1778 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 20:
#line 244 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			char *s = (yyvsp[-2].v.string);
			while (*s++) {
				if (isspace((unsigned char)*s)) {
					yyerror("macro name cannot contain "
					    "whitespace");
					free((yyvsp[-2].v.string));
					free((yyvsp[0].v.string));
					YYERROR;
				}
			}
			if (symset((yyvsp[-2].v.string), (yyvsp[0].v.string), 0) == -1)
				fatal("cannot store variable");
			free((yyvsp[-2].v.string));
			free((yyvsp[0].v.string));
		}
#line 1799 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 27:
#line 274 "../../smtpd/parse.y" /* yacc.c:1648  */
    { (yyval.v.number) = 1; }
#line 1805 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 28:
#line 275 "../../smtpd/parse.y" /* yacc.c:1648  */
    { (yyval.v.number) = 0; }
#line 1811 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 31:
#line 281 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			table->t_type = T_HASH;
			table_add(table, (yyvsp[-2].v.string), (yyvsp[0].v.string));
			free((yyvsp[-2].v.string));
			free((yyvsp[0].v.string));
		}
#line 1822 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 34:
#line 293 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			table->t_type = T_LIST;
			table_add(table, (yyvsp[0].v.string), NULL);
			free((yyvsp[0].v.string));
		}
#line 1832 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 37:
#line 304 "../../smtpd/parse.y" /* yacc.c:1648  */
    { }
#line 1838 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 38:
#line 305 "../../smtpd/parse.y" /* yacc.c:1648  */
    { }
#line 1844 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 39:
#line 309 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	memset(conf->sc_bounce_warn, 0, sizeof conf->sc_bounce_warn);
}
#line 1852 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 41:
#line 316 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	char buf[HOST_NAME_MAX+1];

	/* if not catchall, check that it is a valid domain */
	if (strcmp((yyvsp[0].v.string), "*") != 0) {
		if (!res_hnok((yyvsp[0].v.string))) {
			yyerror("not a valid domain name: %s", (yyvsp[0].v.string));
			free((yyvsp[0].v.string));
			YYERROR;
		}
	}
	xlowercase(buf, (yyvsp[0].v.string), sizeof(buf));
	free((yyvsp[0].v.string));
	sca = dict_get(conf->sc_ca_dict, buf);
	if (sca == NULL) {
		sca = xcalloc(1, sizeof *sca);
		(void)strlcpy(sca->ca_name, buf, sizeof(sca->ca_name));
		dict_set(conf->sc_ca_dict, sca->ca_name, sca);
	}
}
#line 1877 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 43:
#line 340 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	sca->ca_cert_file = (yyvsp[0].v.string);
}
#line 1885 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 46:
#line 352 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	if (dict_get(conf->sc_mda_wrappers, (yyvsp[-1].v.string))) {
		yyerror("mda wrapper already declared with that name: %s", (yyvsp[-1].v.string));
		YYERROR;
	}
	dict_set(conf->sc_mda_wrappers, (yyvsp[-1].v.string), (yyvsp[0].v.string));
}
#line 1897 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 47:
#line 363 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	conf->sc_mta_max_deferred = (yyvsp[0].v.number);
}
#line 1905 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 48:
#line 366 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	struct mta_limits	*d;

	limits = dict_get(conf->sc_limits_dict, (yyvsp[0].v.string));
	if (limits == NULL) {
		limits = xcalloc(1, sizeof(*limits));
		dict_xset(conf->sc_limits_dict, (yyvsp[0].v.string), limits);
		d = dict_xget(conf->sc_limits_dict, "default");
		memmove(limits, d, sizeof(*limits));
	}
	free((yyvsp[0].v.string));
}
#line 1922 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 50:
#line 378 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	limits = dict_get(conf->sc_limits_dict, "default");
}
#line 1930 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 52:
#line 385 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	char buf[HOST_NAME_MAX+1];

	/* if not catchall, check that it is a valid domain */
	if (strcmp((yyvsp[0].v.string), "*") != 0) {
		if (!res_hnok((yyvsp[0].v.string))) {
			yyerror("not a valid domain name: %s", (yyvsp[0].v.string));
			free((yyvsp[0].v.string));
			YYERROR;
		}
	}
	xlowercase(buf, (yyvsp[0].v.string), sizeof(buf));
	free((yyvsp[0].v.string));
	pki = dict_get(conf->sc_pki_dict, buf);
	if (pki == NULL) {
		pki = xcalloc(1, sizeof *pki);
		(void)strlcpy(pki->pki_name, buf, sizeof(pki->pki_name));
		dict_set(conf->sc_pki_dict, pki->pki_name, pki);
	}
}
#line 1955 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 54:
#line 408 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	pki->pki_cert_file = (yyvsp[0].v.string);
}
#line 1963 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 55:
#line 411 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	pki->pki_key_file = (yyvsp[0].v.string);
}
#line 1971 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 56:
#line 414 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	if (strcasecmp((yyvsp[0].v.string), "none") == 0)
		pki->pki_dhe = 0;
	else if (strcasecmp((yyvsp[0].v.string), "auto") == 0)
		pki->pki_dhe = 1;
	else if (strcasecmp((yyvsp[0].v.string), "legacy") == 0)
		pki->pki_dhe = 2;
	else {
		yyerror("invalid DHE keyword: %s", (yyvsp[0].v.string));
		free((yyvsp[0].v.string));
		YYERROR;
	}
	free((yyvsp[0].v.string));
}
#line 1990 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 59:
#line 438 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	conf->sc_queue_flags |= QUEUE_COMPRESSION;
}
#line 1998 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 60:
#line 441 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	conf->sc_queue_flags |= QUEUE_ENCRYPTION;
}
#line 2006 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 61:
#line 444 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	if (strcasecmp((yyvsp[0].v.string), "stdin") == 0 || strcasecmp((yyvsp[0].v.string), "-") == 0) {
		conf->sc_queue_key = "stdin";
		free((yyvsp[0].v.string));
	}
	else
		conf->sc_queue_key = (yyvsp[0].v.string);
	conf->sc_queue_flags |= QUEUE_ENCRYPTION;
}
#line 2020 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 62:
#line 453 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	conf->sc_ttl = delaytonum((yyvsp[0].v.string));
	if (conf->sc_ttl == -1) {
		yyerror("invalid ttl delay: %s", (yyvsp[0].v.string));
		free((yyvsp[0].v.string));
		YYERROR;
	}
	free((yyvsp[0].v.string));
}
#line 2034 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 65:
#line 472 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	conf->sc_tls_ciphers = (yyvsp[0].v.string);
}
#line 2042 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 66:
#line 475 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	conf->sc_maxsize = (yyvsp[0].v.number);
}
#line 2050 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 67:
#line 478 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	if (strlen((yyvsp[0].v.string)) != 1) {
		yyerror("subaddressing-delimiter must be one character");
		free((yyvsp[0].v.string));
		YYERROR;
	}
	if (isspace((int)*(yyvsp[0].v.string)) ||  !isprint((int)*(yyvsp[0].v.string)) || *(yyvsp[0].v.string)== '@') {
		yyerror("sub-addr-delim uses invalid character");
		free((yyvsp[0].v.string));
		YYERROR;
	}
	conf->sc_subaddressing_delim = (yyvsp[0].v.string);
}
#line 2068 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 68:
#line 495 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	if (dispatcher->u.local.requires_root) {
		yyerror("user may not be specified for this dispatcher");
		YYERROR;
	}

	if (dispatcher->u.local.forward_only) {
		yyerror("user may not be specified for forward-only");
		YYERROR;
	}

	if (dispatcher->u.local.expand_only) {
		yyerror("user may not be specified for expand-only");
		YYERROR;
	}

	if (dispatcher->u.local.user) {
		yyerror("user already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.local.user = (yyvsp[0].v.string);
}
#line 2096 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 69:
#line 518 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	struct table   *t = (yyvsp[0].v.table);

	if (dispatcher->u.local.table_alias) {
		yyerror("alias mapping already specified for this dispatcher");
		YYERROR;
	}

	if (dispatcher->u.local.table_virtual) {
		yyerror("virtual mapping already specified for this dispatcher");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_HASH, K_ALIAS)) {
		yyerror("table \"%s\" may not be used for alias lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.local.table_alias = strdup(t->t_name);
}
#line 2122 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 70:
#line 539 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	struct table   *t = (yyvsp[0].v.table);

	if (dispatcher->u.local.table_virtual) {
		yyerror("virtual mapping already specified for this dispatcher");
		YYERROR;
	}

	if (dispatcher->u.local.table_alias) {
		yyerror("alias mapping already specified for this dispatcher");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_HASH, K_ALIAS)) {
		yyerror("table \"%s\" may not be used for virtual lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.local.table_virtual = strdup(t->t_name);
}
#line 2148 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 71:
#line 560 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	struct table   *t = (yyvsp[0].v.table);

	if (dispatcher->u.local.table_userbase) {
		yyerror("userbase mapping already specified for this dispatcher");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_HASH, K_USERINFO)) {
		yyerror("table \"%s\" may not be used for userbase lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.local.table_userbase = strdup(t->t_name);
}
#line 2169 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 72:
#line 576 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	if (! dict_get(conf->sc_mda_wrappers, (yyvsp[0].v.string))) {
		yyerror("no mda wrapper with that name: %s", (yyvsp[0].v.string));
		YYERROR;
	}
	dispatcher->u.local.mda_wrapper = (yyvsp[0].v.string);
}
#line 2181 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 75:
#line 591 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	dispatcher->u.local.requires_root = 1;
	dispatcher->u.local.user = xstrdup("root");
	asprintf(&dispatcher->u.local.command, PATH_LIBEXEC"/mail.local -f %%{mbox.from} %%{user.username}");
}
#line 2191 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 77:
#line 596 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	asprintf(&dispatcher->u.local.command, PATH_LIBEXEC"/mail.maildir");
}
#line 2199 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 79:
#line 599 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	asprintf(&dispatcher->u.local.command, PATH_LIBEXEC"/mail.maildir -j");
}
#line 2207 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 81:
#line 602 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	if (strncmp((yyvsp[0].v.string), "~/", 2) == 0)
		asprintf(&dispatcher->u.local.command,
		    PATH_LIBEXEC"/mail.maildir \"%%{user.directory}/%s\"", (yyvsp[0].v.string)+2);
	else
		asprintf(&dispatcher->u.local.command,
		    PATH_LIBEXEC"/mail.maildir \"%s\"", (yyvsp[0].v.string));
}
#line 2220 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 83:
#line 610 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	if (strncmp((yyvsp[-1].v.string), "~/", 2) == 0)
		asprintf(&dispatcher->u.local.command,
		    PATH_LIBEXEC"/mail.maildir -j \"%%{user.directory}/%s\"", (yyvsp[-1].v.string)+2);
	else
		asprintf(&dispatcher->u.local.command,
		    PATH_LIBEXEC"/mail.maildir -j \"%s\"", (yyvsp[-1].v.string));
}
#line 2233 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 85:
#line 618 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	asprintf(&dispatcher->u.local.command,
	    PATH_LIBEXEC"/mail.lmtp -f %%{mbox.from} -d %s %%{user.username}", (yyvsp[0].v.string));
}
#line 2242 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 87:
#line 622 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	asprintf(&dispatcher->u.local.command,
	    PATH_LIBEXEC"/mail.lmtp -f %%{mbox.from} -d %s %%{dest}", (yyvsp[-1].v.string));
}
#line 2251 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 89:
#line 626 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	asprintf(&dispatcher->u.local.command,
	    PATH_LIBEXEC"/mail.mda \"%s\"", (yyvsp[0].v.string));
}
#line 2260 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 91:
#line 630 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	dispatcher->u.local.forward_only = 1;
}
#line 2268 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 93:
#line 633 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	dispatcher->u.local.expand_only = 1;
}
#line 2276 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 95:
#line 640 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	if (dispatcher->u.remote.helo) {
		yyerror("helo already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.remote.helo = (yyvsp[0].v.string);
}
#line 2289 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 96:
#line 648 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	struct table   *t = (yyvsp[0].v.table);

	if (dispatcher->u.remote.helo_source) {
		yyerror("helo-source mapping already specified for this dispatcher");
		YYERROR;
	}
	if (!table_check_use(t, T_DYNAMIC|T_HASH, K_ADDRNAME)) {
		yyerror("table \"%s\" may not be used for helo-source lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.remote.helo_source = strdup(t->t_name);
}
#line 2309 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 97:
#line 663 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	if (dispatcher->u.remote.pki) {
		yyerror("pki already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.remote.pki = (yyvsp[0].v.string);
}
#line 2322 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 98:
#line 671 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	if (dispatcher->u.remote.ca) {
		yyerror("ca already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.remote.ca = (yyvsp[0].v.string);
}
#line 2335 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 99:
#line 679 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	struct table   *t = (yyvsp[0].v.table);

	if (dispatcher->u.remote.source) {
		yyerror("source mapping already specified for this dispatcher");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_SOURCE)) {
		yyerror("table \"%s\" may not be used for source lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.remote.source = strdup(t->t_name);
}
#line 2356 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 100:
#line 695 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	if (dispatcher->u.remote.mail_from) {
		yyerror("mail-from already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.remote.mail_from = (yyvsp[0].v.string);
}
#line 2369 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 101:
#line 703 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	if (dispatcher->u.remote.backup) {
		yyerror("backup already specified for this dispatcher");
		YYERROR;
	}
	if (dispatcher->u.remote.smarthost) {
		yyerror("backup and host are mutually exclusive");
		YYERROR;
	}

	dispatcher->u.remote.backup = 1;
	dispatcher->u.remote.backupmx = (yyvsp[0].v.string);
}
#line 2387 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 102:
#line 716 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	if (dispatcher->u.remote.backup) {
		yyerror("backup already specified for this dispatcher");
		YYERROR;
	}
	if (dispatcher->u.remote.smarthost) {
		yyerror("backup and host are mutually exclusive");
		YYERROR;
	}

	dispatcher->u.remote.backup = 1;
}
#line 2404 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 103:
#line 728 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	struct table   *t = (yyvsp[0].v.table);

	if (dispatcher->u.remote.smarthost) {
		yyerror("host mapping already specified for this dispatcher");
		YYERROR;
	}
	if (dispatcher->u.remote.backup) {
		yyerror("backup and host are mutually exclusive");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_RELAYHOST)) {
		yyerror("table \"%s\" may not be used for host lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.remote.smarthost = strdup(t->t_name);
}
#line 2429 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 104:
#line 748 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	if (dispatcher->u.remote.tls_required == 1) {
		yyerror("tls already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.remote.tls_required = 1;
}
#line 2442 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 105:
#line 756 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	if (dispatcher->u.remote.tls_required == 1) {
		yyerror("tls already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.remote.tls_required = 1;
	dispatcher->u.remote.tls_noverify = 1;
}
#line 2456 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 106:
#line 765 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	struct table   *t = (yyvsp[0].v.table);

	if (dispatcher->u.remote.smarthost == NULL) {
		yyerror("auth may not be specified without host on a dispatcher");
		YYERROR;
	}

	if (dispatcher->u.remote.auth) {
		yyerror("auth mapping already specified for this dispatcher");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_HASH, K_CREDENTIALS)) {
		yyerror("table \"%s\" may not be used for auth lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.remote.auth = strdup(t->t_name);
}
#line 2482 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 110:
#line 798 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	dispatcher->type = DISPATCHER_LOCAL;
}
#line 2490 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 111:
#line 801 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	dispatcher->type = DISPATCHER_REMOTE;
}
#line 2498 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 112:
#line 807 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	if (dispatcher->ttl) {
		yyerror("ttl already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->ttl = delaytonum((yyvsp[0].v.string));
	if (dispatcher->ttl == -1) {
		yyerror("ttl delay \"%s\" is invalid", (yyvsp[0].v.string));
		free((yyvsp[0].v.string));
		YYERROR;
	}
	free((yyvsp[0].v.string));
}
#line 2517 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 115:
#line 829 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	if (dict_get(conf->sc_dispatchers, (yyvsp[0].v.string))) {
		yyerror("dispatcher already declared with that name: %s", (yyvsp[0].v.string));
		YYERROR;
	}
	dispatcher = xcalloc(1, sizeof *dispatcher);
}
#line 2529 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 116:
#line 835 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	if (dispatcher->type == DISPATCHER_LOCAL)
		if (dispatcher->u.local.table_userbase == NULL)
			dispatcher->u.local.table_userbase = "<getpwnam>";
	dict_set(conf->sc_dispatchers, (yyvsp[-3].v.string), dispatcher);
	dispatcher = NULL;
}
#line 2541 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 117:
#line 845 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_tag) {
		yyerror("tag already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_STRING)) {
		yyerror("table \"%s\" may not be used for tag lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_tag = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_tag = strdup(t->t_name);
}
#line 2563 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 118:
#line 862 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_smtp_helo) {
		yyerror("mail-helo already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_DOMAIN)) {
		yyerror("table \"%s\" may not be used for helo lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_smtp_helo = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_smtp_helo = strdup(t->t_name);
}
#line 2585 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 119:
#line 879 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	if (rule->flag_smtp_starttls) {
		yyerror("tls already specified for this rule");
		YYERROR;
	}
	rule->flag_smtp_starttls = (yyvsp[-1].v.number) ? -1 : 1;
}
#line 2597 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 120:
#line 886 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	if (rule->flag_smtp_auth) {
		yyerror("auth already specified for this rule");
		YYERROR;
	}
	rule->flag_smtp_auth = (yyvsp[-1].v.number) ? -1 : 1;
}
#line 2609 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 121:
#line 893 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_smtp_auth) {
		yyerror("auth already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_CREDENTIALS)) {
		yyerror("table \"%s\" may not be used for auth lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_smtp_auth = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_smtp_auth = strdup(t->t_name);
}
#line 2631 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 122:
#line 910 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_smtp_mail_from) {
		yyerror("mail-from already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_MAILADDR)) {
		yyerror("table \"%s\" may not be used for mail-from lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_smtp_mail_from = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_smtp_mail_from = strdup(t->t_name);
}
#line 2653 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 123:
#line 927 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_smtp_rcpt_to) {
		yyerror("rcpt-to already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_MAILADDR)) {
		yyerror("table \"%s\" may not be used for rcpt-to lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_smtp_rcpt_to = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_smtp_rcpt_to = strdup(t->t_name);
}
#line 2675 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 124:
#line 945 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}
	rule->flag_from = (yyvsp[-2].v.number) ? -1 : 1;
	rule->flag_from_socket = 1;
}
#line 2688 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 125:
#line 953 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	struct table	*t = table_find(conf, "<localhost>", NULL);

	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}
	rule->flag_from = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_from = strdup(t->t_name);
}
#line 2703 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 126:
#line 963 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	struct table	*t = table_find(conf, "<anyhost>", NULL);

	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}
	rule->flag_from = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_from = strdup(t->t_name);
}
#line 2718 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 127:
#line 973 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_NETADDR)) {
		yyerror("table \"%s\" may not be used for from lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_from = (yyvsp[-3].v.number) ? -1 : 1;
	rule->table_from = strdup(t->t_name);
}
#line 2740 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 128:
#line 991 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	struct table   *t = table_find(conf, "<localnames>", NULL);

	if (rule->flag_for) {
		yyerror("for already specified for this rule");
		YYERROR;
	}
	rule->flag_for = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_for = strdup(t->t_name);
}
#line 2755 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 129:
#line 1001 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	struct table   *t = table_find(conf, "<anydestination>", NULL);

	if (rule->flag_for) {
		yyerror("for already specified for this rule");
		YYERROR;
	}
	rule->flag_for = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_for = strdup(t->t_name);
}
#line 2770 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 130:
#line 1011 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_for) {
		yyerror("for already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_DOMAIN)) {
		yyerror("table \"%s\" may not be used for 'for' lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_for = (yyvsp[-3].v.number) ? -1 : 1;
	rule->table_for = strdup(t->t_name);
}
#line 2792 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 133:
#line 1036 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	if (dict_get(conf->sc_dispatchers, (yyvsp[0].v.string)) == NULL) {
		yyerror("no such dispatcher: %s", (yyvsp[0].v.string));
		YYERROR;
	}
	rule->dispatcher = (yyvsp[0].v.string);
}
#line 2804 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 134:
#line 1046 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	rule->reject = 1;
}
#line 2812 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 136:
#line 1053 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	rule = xcalloc(1, sizeof *rule);
}
#line 2820 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 137:
#line 1055 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
	if (!rule->flag_from) {
		rule->table_from = strdup("<localhost>");
		rule->flag_from = 1;
	}
	if (!rule->flag_for) {
		rule->table_for = strdup("<localnames>");
		rule->flag_for = 1;
	}
	TAILQ_INSERT_TAIL(conf->sc_rules, rule, r_entry);
	rule = NULL;
}
#line 2837 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 138:
#line 1069 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if ((yyvsp[0].v.number) < 0) {
				yyerror("invalid size: %" PRId64, (yyvsp[0].v.number));
				YYERROR;
			}
			(yyval.v.number) = (yyvsp[0].v.number);
		}
#line 2849 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 139:
#line 1076 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			long long result;

			if (scan_scaled((yyvsp[0].v.string), &result) == -1 || result < 0) {
				yyerror("invalid size: %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			free((yyvsp[0].v.string));
			(yyval.v.number) = result;
		}
#line 2865 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 140:
#line 1089 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			time_t	d;
			int	i;

			d = delaytonum((yyvsp[0].v.string));
			if (d < 0) {
				yyerror("invalid bounce delay: %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			free((yyvsp[0].v.string));
			for (i = 0; i < MAX_BOUNCE_WARN; i++) {
				if (conf->sc_bounce_warn[i] != 0)
					continue;
				conf->sc_bounce_warn[i] = d;
				break;
			}
		}
#line 2888 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 143:
#line 1113 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (!strcmp((yyvsp[-1].v.string), "max-session")) {
				conf->sc_mda_max_session = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "max-session-per-user")) {
				conf->sc_mda_max_user_session = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "task-lowat")) {
				conf->sc_mda_task_lowat = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "task-hiwat")) {
				conf->sc_mda_task_hiwat = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "task-release")) {
				conf->sc_mda_task_release = (yyvsp[0].v.number);
			}
			else {
				yyerror("invalid scheduler limit keyword: %s", (yyvsp[-1].v.string));
				free((yyvsp[-1].v.string));
				YYERROR;
			}
			free((yyvsp[-1].v.string));
		}
#line 2916 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 146:
#line 1142 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (!strcmp((yyvsp[-1].v.string), "max-rcpt")) {
				conf->sc_session_max_rcpt = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "max-mails")) {
				conf->sc_session_max_mails = (yyvsp[0].v.number);
			}
			else {
				yyerror("invalid session limit keyword: %s", (yyvsp[-1].v.string));
				free((yyvsp[-1].v.string));
				YYERROR;
			}
			free((yyvsp[-1].v.string));
		}
#line 2935 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 149:
#line 1162 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			limits->family = AF_INET;
		}
#line 2943 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 150:
#line 1165 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			limits->family = AF_INET6;
		}
#line 2951 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 151:
#line 1168 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (!limit_mta_set(limits, (yyvsp[-1].v.string), (yyvsp[0].v.number))) {
				yyerror("invalid mta limit keyword: %s", (yyvsp[-1].v.string));
				free((yyvsp[-1].v.string));
				YYERROR;
			}
			free((yyvsp[-1].v.string));
		}
#line 2964 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 154:
#line 1182 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (!strcmp((yyvsp[-1].v.string), "max-inflight")) {
				conf->sc_scheduler_max_inflight = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "max-evp-batch-size")) {
				conf->sc_scheduler_max_evp_batch_size = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "max-msg-batch-size")) {
				conf->sc_scheduler_max_msg_batch_size = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "max-schedule")) {
				conf->sc_scheduler_max_schedule = (yyvsp[0].v.number);
			}
			else {
				yyerror("invalid scheduler limit keyword: %s", (yyvsp[-1].v.string));
				free((yyvsp[-1].v.string));
				YYERROR;
			}
			free((yyvsp[-1].v.string));
		}
#line 2989 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 157:
#line 1209 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (config_lo_filter(&listen_opts, (yyvsp[0].v.string))) {
				YYERROR;
			}
		}
#line 2999 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 158:
#line 1214 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (config_lo_mask_source(&listen_opts)) {
				YYERROR;
			}
		}
#line 3009 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 159:
#line 1221 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (listen_opts.options & LO_FAMILY) {
				yyerror("address family already specified");
				YYERROR;
			}
			listen_opts.options |= LO_FAMILY;
			listen_opts.family = AF_INET;
		}
#line 3022 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 160:
#line 1229 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (listen_opts.options & LO_FAMILY) {
				yyerror("address family already specified");
				YYERROR;
			}
			listen_opts.options |= LO_FAMILY;
			listen_opts.family = AF_INET6;
		}
#line 3035 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 161:
#line 1237 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			struct servent	*servent;

			if (listen_opts.options & LO_PORT) {
				yyerror("port already specified");
				YYERROR;
			}
			listen_opts.options |= LO_PORT;

			servent = getservbyname((yyvsp[0].v.string), "tcp");
			if (servent == NULL) {
				yyerror("invalid port: %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			free((yyvsp[0].v.string));
			listen_opts.port = ntohs(servent->s_port);
		}
#line 3058 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 162:
#line 1255 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (listen_opts.options & LO_PORT) {
				yyerror("port already specified");
				YYERROR;
			}
			listen_opts.options |= LO_PORT;

			if ((yyvsp[0].v.number) <= 0 || (yyvsp[0].v.number) > (int)USHRT_MAX) {
				yyerror("invalid port: %" PRId64, (yyvsp[0].v.number));
				YYERROR;
			}
			listen_opts.port = (yyvsp[0].v.number);
		}
#line 3076 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 163:
#line 1268 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (config_lo_filter(&listen_opts, (yyvsp[0].v.string))) {
				YYERROR;
			}
		}
#line 3086 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 164:
#line 1273 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_SMTPS;
		}
#line 3099 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 165:
#line 1281 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_SMTPS|F_TLS_VERIFY;
		}
#line 3112 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 166:
#line 1289 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_STARTTLS;
		}
#line 3125 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 167:
#line 1297 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_STARTTLS|F_STARTTLS_REQUIRE;
		}
#line 3138 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 168:
#line 1305 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_STARTTLS|F_STARTTLS_REQUIRE|F_TLS_VERIFY;
		}
#line 3151 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 169:
#line 1313 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (listen_opts.options & LO_PKI) {
				yyerror("pki already specified");
				YYERROR;
			}
			listen_opts.options |= LO_PKI;
			listen_opts.pki = (yyvsp[0].v.string);
		}
#line 3164 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 170:
#line 1321 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (listen_opts.options & LO_CA) {
				yyerror("ca already specified");
				YYERROR;
			}
			listen_opts.options |= LO_CA;
			listen_opts.ca = (yyvsp[0].v.string);
		}
#line 3177 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 171:
#line 1329 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.auth = F_AUTH|F_AUTH_REQUIRE;
		}
#line 3190 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 172:
#line 1337 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.auth = F_AUTH;
		}
#line 3203 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 173:
#line 1345 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.authtable = (yyvsp[0].v.table);
			listen_opts.auth = F_AUTH|F_AUTH_REQUIRE;
		}
#line 3217 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 174:
#line 1354 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.authtable = (yyvsp[0].v.table);
			listen_opts.auth = F_AUTH;
		}
#line 3231 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 175:
#line 1363 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (listen_opts.options & LO_TAG) {
				yyerror("tag already specified");
				YYERROR;
			}
			listen_opts.options |= LO_TAG;

			if (strlen((yyvsp[0].v.string)) >= SMTPD_TAG_SIZE) {
       				yyerror("tag name too long");
				free((yyvsp[0].v.string));
				YYERROR;
			}
			listen_opts.tag = (yyvsp[0].v.string);
		}
#line 3250 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 176:
#line 1377 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (listen_opts.options & LO_HOSTNAME) {
				yyerror("hostname already specified");
				YYERROR;
			}
			listen_opts.options |= LO_HOSTNAME;

			listen_opts.hostname = (yyvsp[0].v.string);
		}
#line 3264 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 177:
#line 1386 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			struct table	*t = (yyvsp[0].v.table);

			if (listen_opts.options & LO_HOSTNAMES) {
				yyerror("hostnames already specified");
				YYERROR;
			}
			listen_opts.options |= LO_HOSTNAMES;

			if (!table_check_use(t, T_DYNAMIC|T_HASH, K_ADDRNAME)) {
				yyerror("invalid use of table \"%s\" as "
				    "HOSTNAMES parameter", t->t_name);
				YYERROR;
			}
			listen_opts.hostnametable = t;
		}
#line 3285 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 178:
#line 1402 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (config_lo_mask_source(&listen_opts)) {
				YYERROR;
			}
		}
#line 3295 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 179:
#line 1407 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (listen_opts.options & LO_RECEIVEDAUTH) {
				yyerror("received-auth already specified");
				YYERROR;
			}
			listen_opts.options |= LO_RECEIVEDAUTH;
			listen_opts.flags |= F_RECEIVEDAUTH;
		}
#line 3308 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 180:
#line 1415 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (listen_opts.options & LO_NODSN) {
				yyerror("no-dsn already specified");
				YYERROR;
			}
			listen_opts.options |= LO_NODSN;
			listen_opts.flags &= ~F_EXT_DSN;
		}
#line 3321 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 181:
#line 1423 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			struct table	*t = (yyvsp[0].v.table);

			if (listen_opts.options & LO_SENDERS) {
				yyerror("senders already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SENDERS;

			if (!table_check_use(t, T_DYNAMIC|T_HASH, K_MAILADDRMAP)) {
				yyerror("invalid use of table \"%s\" as "
				    "SENDERS parameter", t->t_name);
				YYERROR;
			}
			listen_opts.sendertable = t;
		}
#line 3342 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 182:
#line 1439 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			struct table	*t = (yyvsp[-1].v.table);

			if (listen_opts.options & LO_SENDERS) {
				yyerror("senders already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SENDERS|LO_MASQUERADE;

			if (!table_check_use(t, T_DYNAMIC|T_HASH, K_MAILADDRMAP)) {
				yyerror("invalid use of table \"%s\" as "
				    "SENDERS parameter", t->t_name);
				YYERROR;
			}
			listen_opts.sendertable = t;
		}
#line 3363 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 185:
#line 1461 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			if (conf->sc_sock_listener) {
				yyerror("socket listener already configured");
				YYERROR;
			}
			create_sock_listener(&listen_opts);
		}
#line 3375 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 186:
#line 1470 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			listen_opts.ifx = (yyvsp[-1].v.string);
			create_if_listener(&listen_opts);
		}
#line 3384 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 191:
#line 1485 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			memset(&listen_opts, 0, sizeof listen_opts);
			listen_opts.family = AF_UNSPEC;
			listen_opts.flags |= F_EXT_DSN;
		}
#line 3394 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 193:
#line 1492 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			char *p, *backend, *config;

			p = (yyvsp[0].v.string);
			if (*p == '/') {
				backend = "static";
				config = (yyvsp[0].v.string);
			}
			else {
				backend = (yyvsp[0].v.string);
				config = NULL;
				for (p = (yyvsp[0].v.string); *p && *p != ':'; p++)
					;
				if (*p == ':') {
					*p = '\0';
					backend = (yyvsp[0].v.string);
					config  = p+1;
				}
			}
			if (config != NULL && *config != '/') {
				yyerror("invalid backend parameter for table: %s",
				    (yyvsp[-1].v.string));
				free((yyvsp[-1].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			table = table_create(conf, backend, (yyvsp[-1].v.string), NULL, config);
			if (!table_config(table)) {
				yyerror("invalid configuration file %s for table %s",
				    config, table->t_name);
				free((yyvsp[-1].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			table = NULL;
			free((yyvsp[-1].v.string));
			free((yyvsp[0].v.string));
		}
#line 3437 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 194:
#line 1530 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			table = table_create(conf, "static", (yyvsp[0].v.string), NULL, NULL);
			free((yyvsp[0].v.string));
		}
#line 3446 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 195:
#line 1533 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			table = NULL;
		}
#line 3454 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 196:
#line 1538 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			struct table	*t;

			t = table_create(conf, "static", NULL, NULL, NULL);
			t->t_type = T_LIST;
			table_add(t, (yyvsp[0].v.string), NULL);
			free((yyvsp[0].v.string));
			(yyval.v.table) = t;
		}
#line 3468 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 197:
#line 1547 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			table = table_create(conf, "static", NULL, NULL, NULL);
		}
#line 3476 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 198:
#line 1549 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			(yyval.v.table) = table;
			table = NULL;
		}
#line 3485 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 199:
#line 1555 "../../smtpd/parse.y" /* yacc.c:1648  */
    {
			struct table	*t;

			if ((t = table_find(conf, (yyvsp[-1].v.string), NULL)) == NULL) {
				yyerror("no such table: %s", (yyvsp[-1].v.string));
				free((yyvsp[-1].v.string));
				YYERROR;
			}
			free((yyvsp[-1].v.string));
			(yyval.v.table) = t;
		}
#line 3501 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 200:
#line 1568 "../../smtpd/parse.y" /* yacc.c:1648  */
    { (yyval.v.table) = (yyvsp[0].v.table); }
#line 3507 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;

  case 201:
#line 1569 "../../smtpd/parse.y" /* yacc.c:1648  */
    { (yyval.v.table) = (yyvsp[0].v.table); }
#line 3513 "../../smtpd/parse.c" /* yacc.c:1648  */
    break;


#line 3517 "../../smtpd/parse.c" /* yacc.c:1648  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1573 "../../smtpd/parse.y" /* yacc.c:1907  */


struct keywords {
	const char	*k_name;
	int		 k_val;
};

int
yyerror(const char *fmt, ...)
{
	va_list		 ap;
	char		*msg;

	file->errors++;
	va_start(ap, fmt);
	if (vasprintf(&msg, fmt, ap) == -1)
		fatalx("yyerror vasprintf");
	va_end(ap);
	logit(LOG_CRIT, "%s:%d: %s", file->name, yylval.lineno, msg);
	free(msg);
	return (0);
}

int
kw_cmp(const void *k, const void *e)
{
	return (strcmp(k, ((const struct keywords *)e)->k_name));
}

int
lookup(char *s)
{
	/* this has to be sorted always */
	static const struct keywords keywords[] = {
		{ "action",		ACTION },
		{ "alias",		ALIAS },
		{ "any",		ANY },
		{ "auth",		AUTH },
		{ "auth-optional",     	AUTH_OPTIONAL },
		{ "backup",		BACKUP },
		{ "bounce",		BOUNCE },
		{ "ca",			CA },
		{ "cert",		CERT },
		{ "ciphers",		CIPHERS },
		{ "compression",	COMPRESSION },
		{ "dhe",		DHE },
		{ "domain",		DOMAIN },
		{ "encryption",		ENCRYPTION },
		{ "expand-only",      	EXPAND_ONLY },
		{ "filter",		FILTER },
		{ "for",		FOR },
		{ "forward-only",      	FORWARD_ONLY },
		{ "from",		FROM },
		{ "helo",		HELO },
		{ "helo-src",       	HELO_SRC },
		{ "host",		HOST },
		{ "hostname",		HOSTNAME },
		{ "hostnames",		HOSTNAMES },
		{ "include",		INCLUDE },
		{ "inet4",		INET4 },
		{ "inet6",		INET6 },
		{ "junk",		JUNK },
		{ "key",		KEY },
		{ "limit",		LIMIT },
		{ "listen",		LISTEN },
		{ "lmtp",		LMTP },
		{ "local",		LOCAL },
		{ "mail-from",		MAIL_FROM },
		{ "maildir",		MAILDIR },
		{ "mask-src",		MASK_SRC },
		{ "masquerade",		MASQUERADE },
		{ "match",		MATCH },
		{ "max-deferred",  	MAX_DEFERRED },
		{ "max-message-size",  	MAX_MESSAGE_SIZE },
		{ "mbox",		MBOX },
		{ "mda",		MDA },
		{ "mta",		MTA },
		{ "mx",			MX },
		{ "no-dsn",		NO_DSN },
		{ "no-verify",		NO_VERIFY },
		{ "on",			ON },
		{ "pki",		PKI },
		{ "port",		PORT },
		{ "queue",		QUEUE },
		{ "rcpt-to",		RCPT_TO },
		{ "received-auth",     	RECEIVEDAUTH },
		{ "recipient",		RECIPIENT },
		{ "reject",		REJECT },
		{ "relay",		RELAY },
		{ "scheduler",		SCHEDULER },
		{ "senders",   		SENDERS },
		{ "smtp",		SMTP },
		{ "smtps",		SMTPS },
		{ "socket",		SOCKET },
		{ "src",		SRC },
		{ "sub-addr-delim",	SUB_ADDR_DELIM },
		{ "table",		TABLE },
		{ "tag",		TAG },
		{ "tagged",		TAGGED },
		{ "tls",		TLS },
		{ "tls-require",       	TLS_REQUIRE },
		{ "to",			TO },
		{ "ttl",		TTL },
		{ "user",		USER },
		{ "userbase",		USERBASE },
		{ "verify",		VERIFY },
		{ "virtual",		VIRTUAL },
		{ "warn-interval",	WARN_INTERVAL },
		{ "wrapper",		WRAPPER },
	};
	const struct keywords	*p;

	p = bsearch(s, keywords, sizeof(keywords)/sizeof(keywords[0]),
	    sizeof(keywords[0]), kw_cmp);

	if (p)
		return (p->k_val);
	else
		return (STRING);
}

#define START_EXPAND	1
#define DONE_EXPAND	2

static int	expanding;

int
igetc(void)
{
	int	c;

	while (1) {
		if (file->ungetpos > 0)
			c = file->ungetbuf[--file->ungetpos];
		else
			c = getc(file->stream);

		if (c == START_EXPAND)
			expanding = 1;
		else if (c == DONE_EXPAND)
			expanding = 0;
		else
			break;
	}
	return (c);
}

int
lgetc(int quotec)
{
	int		c, next;

	if (quotec) {
		if ((c = igetc()) == EOF) {
			yyerror("reached end of file while parsing "
			    "quoted string");
			if (file == topfile || popfile() == EOF)
				return (EOF);
			return (quotec);
		}
		return (c);
	}

	while ((c = igetc()) == '\\') {
		next = igetc();
		if (next != '\n') {
			c = next;
			break;
		}
		yylval.lineno = file->lineno;
		file->lineno++;
	}

	if (c == EOF) {
		/*
		 * Fake EOL when hit EOF for the first time. This gets line
		 * count right if last line in included file is syntactically
		 * invalid and has no newline.
		 */
		if (file->eof_reached == 0) {
			file->eof_reached = 1;
			return ('\n');
		}
		while (c == EOF) {
			if (file == topfile || popfile() == EOF)
				return (EOF);
			c = igetc();
		}
	}
	return (c);
}

void
lungetc(int c)
{
	if (c == EOF)
		return;

	if (file->ungetpos >= file->ungetsize) {
		void *p = reallocarray(file->ungetbuf, file->ungetsize, 2);
		if (p == NULL)
			err(1, "%s", __func__);
		file->ungetbuf = p;
		file->ungetsize *= 2;
	}
	file->ungetbuf[file->ungetpos++] = c;
}

int
findeol(void)
{
	int	c;

	/* skip to either EOF or the first real EOL */
	while (1) {
		c = lgetc(0);
		if (c == '\n') {
			file->lineno++;
			break;
		}
		if (c == EOF)
			break;
	}
	return (ERROR);
}

int
yylex(void)
{
	unsigned char	 buf[8096];
	unsigned char	*p, *val;
	int		 quotec, next, c;
	int		 token;

top:
	p = buf;
	while ((c = lgetc(0)) == ' ' || c == '\t')
		; /* nothing */

	yylval.lineno = file->lineno;
	if (c == '#')
		while ((c = lgetc(0)) != '\n' && c != EOF)
			; /* nothing */
	if (c == '$' && !expanding) {
		while (1) {
			if ((c = lgetc(0)) == EOF)
				return (0);

			if (p + 1 >= buf + sizeof(buf) - 1) {
				yyerror("string too long");
				return (findeol());
			}
			if (isalnum(c) || c == '_') {
				*p++ = c;
				continue;
			}
			*p = '\0';
			lungetc(c);
			break;
		}
		val = symget(buf);
		if (val == NULL) {
			yyerror("macro '%s' not defined", buf);
			return (findeol());
		}
		p = val + strlen(val) - 1;
		lungetc(DONE_EXPAND);
		while (p >= val) {
			lungetc(*p);
			p--;
		}
		lungetc(START_EXPAND);
		goto top;
	}

	switch (c) {
	case '\'':
	case '"':
		quotec = c;
		while (1) {
			if ((c = lgetc(quotec)) == EOF)
				return (0);
			if (c == '\n') {
				file->lineno++;
				continue;
			} else if (c == '\\') {
				if ((next = lgetc(quotec)) == EOF)
					return (0);
				if (next == quotec || c == ' ' || c == '\t')
					c = next;
				else if (next == '\n') {
					file->lineno++;
					continue;
				} else
					lungetc(next);
			} else if (c == quotec) {
				*p = '\0';
				break;
			} else if (c == '\0') {
				yyerror("syntax error");
				return (findeol());
			}
			if (p + 1 >= buf + sizeof(buf) - 1) {
				yyerror("string too long");
				return (findeol());
			}
			*p++ = c;
		}
		yylval.v.string = strdup(buf);
		if (yylval.v.string == NULL)
			err(1, "%s", __func__);
		return (STRING);
	}

#define allowed_to_end_number(x) \
	(isspace(x) || x == ')' || x ==',' || x == '/' || x == '}' || x == '=')

	if (c == '-' || isdigit(c)) {
		do {
			*p++ = c;
			if ((unsigned)(p-buf) >= sizeof(buf)) {
				yyerror("string too long");
				return (findeol());
			}
		} while ((c = lgetc(0)) != EOF && isdigit(c));
		lungetc(c);
		if (p == buf + 1 && buf[0] == '-')
			goto nodigits;
		if (c == EOF || allowed_to_end_number(c)) {
			const char *errstr = NULL;

			*p = '\0';
			yylval.v.number = strtonum(buf, LLONG_MIN,
			    LLONG_MAX, &errstr);
			if (errstr) {
				yyerror("\"%s\" invalid number: %s",
				    buf, errstr);
				return (findeol());
			}
			return (NUMBER);
		} else {
nodigits:
			while (p > buf + 1)
				lungetc(*--p);
			c = *--p;
			if (c == '-')
				return (c);
		}
	}

	if (c == '=') {
		if ((c = lgetc(0)) != EOF && c == '>')
			return (ARROW);
		lungetc(c);
		c = '=';
	}

#define allowed_in_string(x) \
	(isalnum(x) || (ispunct(x) && x != '(' && x != ')' && \
	x != '{' && x != '}' && x != '<' && x != '>' && \
	x != '!' && x != '=' && x != '#' && \
	x != ','))

	if (isalnum(c) || c == ':' || c == '_') {
		do {
			*p++ = c;
			if ((unsigned)(p-buf) >= sizeof(buf)) {
				yyerror("string too long");
				return (findeol());
			}
		} while ((c = lgetc(0)) != EOF && (allowed_in_string(c)));
		lungetc(c);
		*p = '\0';
		if ((token = lookup(buf)) == STRING)
			if ((yylval.v.string = strdup(buf)) == NULL)
				err(1, "%s", __func__);
		return (token);
	}
	if (c == '\n') {
		yylval.lineno = file->lineno;
		file->lineno++;
	}
	if (c == EOF)
		return (0);
	return (c);
}

int
check_file_secrecy(int fd, const char *fname)
{
	struct stat	st;

	if (fstat(fd, &st)) {
		log_warn("warn: cannot stat %s", fname);
		return (-1);
	}
	if (st.st_uid != 0 && st.st_uid != getuid()) {
		log_warnx("warn: %s: owner not root or current user", fname);
		return (-1);
	}
	if (st.st_mode & (S_IWGRP | S_IXGRP | S_IRWXO)) {
		log_warnx("warn: %s: group/world readable/writeable", fname);
		return (-1);
	}
	return (0);
}

struct file *
pushfile(const char *name, int secret)
{
	struct file	*nfile;

	if ((nfile = calloc(1, sizeof(struct file))) == NULL) {
		log_warn("%s", __func__);
		return (NULL);
	}
	if ((nfile->name = strdup(name)) == NULL) {
		log_warn("%s", __func__);
		free(nfile);
		return (NULL);
	}
	if ((nfile->stream = fopen(nfile->name, "r")) == NULL) {
		log_warn("%s: %s", __func__, nfile->name);
		free(nfile->name);
		free(nfile);
		return (NULL);
	} else if (secret &&
	    check_file_secrecy(fileno(nfile->stream), nfile->name)) {
		fclose(nfile->stream);
		free(nfile->name);
		free(nfile);
		return (NULL);
	}
	nfile->lineno = TAILQ_EMPTY(&files) ? 1 : 0;
	nfile->ungetsize = 16;
	nfile->ungetbuf = malloc(nfile->ungetsize);
	if (nfile->ungetbuf == NULL) {
		log_warn("%s", __func__);
		fclose(nfile->stream);
		free(nfile->name);
		free(nfile);
		return (NULL);
	}
	TAILQ_INSERT_TAIL(&files, nfile, entry);
	return (nfile);
}

int
popfile(void)
{
	struct file	*prev;

	if ((prev = TAILQ_PREV(file, files, entry)) != NULL)
		prev->errors += file->errors;

	TAILQ_REMOVE(&files, file, entry);
	fclose(file->stream);
	free(file->name);
	free(file->ungetbuf);
	free(file);
	file = prev;
	return (file ? 0 : EOF);
}

int
parse_config(struct smtpd *x_conf, const char *filename, int opts)
{
	struct sym     *sym, *next;

	conf = x_conf;
	errors = 0;

	if ((file = pushfile(filename, 0)) == NULL) {
		purge_config(PURGE_EVERYTHING);
		return (-1);
	}
	topfile = file;

	/*
	 * parse configuration
	 */
	setservent(1);
	yyparse();
	errors = file->errors;
	popfile();
	endservent();

	/* If the socket listener was not configured, create a default one. */
	if (!conf->sc_sock_listener) {
		memset(&listen_opts, 0, sizeof listen_opts);
		create_sock_listener(&listen_opts);
	}

	/* Free macros and check which have not been used. */
	TAILQ_FOREACH_SAFE(sym, &symhead, entry, next) {
		if ((conf->sc_opts & SMTPD_OPT_VERBOSE) && !sym->used)
			fprintf(stderr, "warning: macro '%s' not "
			    "used\n", sym->nam);
		if (!sym->persist) {
			free(sym->nam);
			free(sym->val);
			TAILQ_REMOVE(&symhead, sym, entry);
			free(sym);
		}
	}

	if (TAILQ_EMPTY(conf->sc_rules)) {
		log_warnx("warn: no rules, nothing to do");
		errors++;
	}

	if (errors) {
		purge_config(PURGE_EVERYTHING);
		return (-1);
	}

	return (0);
}

int
symset(const char *nam, const char *val, int persist)
{
	struct sym	*sym;

	TAILQ_FOREACH(sym, &symhead, entry) {
		if (strcmp(nam, sym->nam) == 0)
			break;
	}

	if (sym != NULL) {
		if (sym->persist == 1)
			return (0);
		else {
			free(sym->nam);
			free(sym->val);
			TAILQ_REMOVE(&symhead, sym, entry);
			free(sym);
		}
	}
	if ((sym = calloc(1, sizeof(*sym))) == NULL)
		return (-1);

	sym->nam = strdup(nam);
	if (sym->nam == NULL) {
		free(sym);
		return (-1);
	}
	sym->val = strdup(val);
	if (sym->val == NULL) {
		free(sym->nam);
		free(sym);
		return (-1);
	}
	sym->used = 0;
	sym->persist = persist;
	TAILQ_INSERT_TAIL(&symhead, sym, entry);
	return (0);
}

int
cmdline_symset(char *s)
{
	char	*sym, *val;
	int	ret;

	if ((val = strrchr(s, '=')) == NULL)
		return (-1);
	sym = strndup(s, val - s);
	if (sym == NULL)
		errx(1, "%s: strndup", __func__);
	ret = symset(sym, val + 1, 1);
	free(sym);

	return (ret);
}

char *
symget(const char *nam)
{
	struct sym	*sym;

	TAILQ_FOREACH(sym, &symhead, entry) {
		if (strcmp(nam, sym->nam) == 0) {
			sym->used = 1;
			return (sym->val);
		}
	}
	return (NULL);
}

static void
create_sock_listener(struct listen_opts *lo)
{
	struct listener *l = xcalloc(1, sizeof(*l));
	lo->tag = "local";
	lo->hostname = conf->sc_hostname;
	l->ss.ss_family = AF_LOCAL;
#ifdef HAVE_STRUCT_SOCKADDR_STORAGE_SS_LEN
	l->ss.ss_len = sizeof(struct sockaddr *);
#endif
	l->local = 1;
	conf->sc_sock_listener = l;
	config_listener(l, lo);
}

static void
create_if_listener(struct listen_opts *lo)
{
	uint16_t	flags;

	if (lo->port != 0 && lo->ssl == F_SSL)
		errx(1, "invalid listen option: tls/smtps on same port");

	if (lo->auth != 0 && !lo->ssl)
		errx(1, "invalid listen option: auth requires tls/smtps");

	if (lo->pki && !lo->ssl)
		errx(1, "invalid listen option: pki requires tls/smtps");

	flags = lo->flags;

	if (lo->port) {
		lo->flags = lo->ssl|lo->auth|flags;
		lo->port = htons(lo->port);
	}
	else {
		if (lo->ssl & F_SMTPS) {
			lo->port = htons(465);
			lo->flags = F_SMTPS|lo->auth|flags;
		}

		if (!lo->ssl || (lo->ssl & F_STARTTLS)) {
			lo->port = htons(25);
			lo->flags = lo->auth|flags;
			if (lo->ssl & F_STARTTLS)
				lo->flags |= F_STARTTLS;
		}
	}

	if (interface(lo))
		return;
	if (host_v4(lo))
		return;
	if (host_v6(lo))
		return;
	if (host_dns(lo))
		return;

	errx(1, "invalid virtual ip or interface: %s", lo->ifx);
}

static void
config_listener(struct listener *h,  struct listen_opts *lo)
{
	h->fd = -1;
	h->port = lo->port;
	h->flags = lo->flags;

	if (lo->hostname == NULL)
		lo->hostname = conf->sc_hostname;

	if (lo->filtername)
		(void)strlcpy(h->filter, lo->filtername, sizeof(h->filter));

	h->pki_name[0] = '\0';

	if (lo->authtable != NULL)
		(void)strlcpy(h->authtable, lo->authtable->t_name, sizeof(h->authtable));
	if (lo->pki != NULL) {
		if (!lowercase(h->pki_name, lo->pki, sizeof(h->pki_name))) {
			log_warnx("pki name too long: %s", lo->pki);
			fatalx(NULL);
		}
		if (dict_get(conf->sc_pki_dict, h->pki_name) == NULL) {
			log_warnx("pki name not found: %s", lo->pki);
			fatalx(NULL);
		}
	}

	if (lo->ca != NULL) {
		if (!lowercase(h->ca_name, lo->ca, sizeof(h->ca_name))) {
			log_warnx("ca name too long: %s", lo->ca);
			fatalx(NULL);
		}
		if (dict_get(conf->sc_ca_dict, h->ca_name) == NULL) {
			log_warnx("ca name not found: %s", lo->ca);
			fatalx(NULL);
		}
	}
	if (lo->tag != NULL)
		(void)strlcpy(h->tag, lo->tag, sizeof(h->tag));

	(void)strlcpy(h->hostname, lo->hostname, sizeof(h->hostname));
	if (lo->hostnametable)
		(void)strlcpy(h->hostnametable, lo->hostnametable->t_name, sizeof(h->hostnametable));
	if (lo->sendertable) {
		(void)strlcpy(h->sendertable, lo->sendertable->t_name, sizeof(h->sendertable));
		if (lo->options & LO_MASQUERADE)
			h->flags |= F_MASQUERADE;
	}

	if (lo->ssl & F_TLS_VERIFY)
		h->flags |= F_TLS_VERIFY;

	if (lo->ssl & F_STARTTLS_REQUIRE)
		h->flags |= F_STARTTLS_REQUIRE;
	
	if (h != conf->sc_sock_listener)
		TAILQ_INSERT_TAIL(conf->sc_listeners, h, entry);
}

static int
host_v4(struct listen_opts *lo)
{
	struct in_addr		 ina;
	struct sockaddr_in	*sain;
	struct listener		*h;

	if (lo->family != AF_UNSPEC && lo->family != AF_INET)
		return (0);

	memset(&ina, 0, sizeof(ina));
	if (inet_pton(AF_INET, lo->ifx, &ina) != 1)
		return (0);

	h = xcalloc(1, sizeof(*h));
	sain = (struct sockaddr_in *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
	sain->sin_len = sizeof(struct sockaddr_in);
#endif
	sain->sin_family = AF_INET;
	sain->sin_addr.s_addr = ina.s_addr;
	sain->sin_port = lo->port;

	if (sain->sin_addr.s_addr == htonl(INADDR_LOOPBACK))
		h->local = 1;
	config_listener(h,  lo);

	return (1);
}

static int
host_v6(struct listen_opts *lo)
{
	struct in6_addr		 ina6;
	struct sockaddr_in6	*sin6;
	struct listener		*h;

	if (lo->family != AF_UNSPEC && lo->family != AF_INET6)
		return (0);

	memset(&ina6, 0, sizeof(ina6));
	if (inet_pton(AF_INET6, lo->ifx, &ina6) != 1)
		return (0);

	h = xcalloc(1, sizeof(*h));
	sin6 = (struct sockaddr_in6 *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
	sin6->sin6_len = sizeof(struct sockaddr_in6);
#endif
	sin6->sin6_family = AF_INET6;
	sin6->sin6_port = lo->port;
	memcpy(&sin6->sin6_addr, &ina6, sizeof(ina6));

	if (IN6_IS_ADDR_LOOPBACK(&sin6->sin6_addr))
		h->local = 1;
	config_listener(h,  lo);

	return (1);
}

static int
host_dns(struct listen_opts *lo)
{
	struct addrinfo		 hints, *res0, *res;
	int			 error, cnt = 0;
	struct sockaddr_in	*sain;
	struct sockaddr_in6	*sin6;
	struct listener		*h;

	memset(&hints, 0, sizeof(hints));
	hints.ai_family = lo->family;
	hints.ai_socktype = SOCK_STREAM;
	hints.ai_flags = AI_ADDRCONFIG;
	error = getaddrinfo(lo->ifx, NULL, &hints, &res0);
	if (error == EAI_AGAIN || error == EAI_NODATA || error == EAI_NONAME)
		return (0);
	if (error) {
		log_warnx("warn: host_dns: could not parse \"%s\": %s", lo->ifx,
		    gai_strerror(error));
		return (-1);
	}

	for (res = res0; res; res = res->ai_next) {
		if (res->ai_family != AF_INET &&
		    res->ai_family != AF_INET6)
			continue;
		h = xcalloc(1, sizeof(*h));

		h->ss.ss_family = res->ai_family;
		if (res->ai_family == AF_INET) {
			sain = (struct sockaddr_in *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
			sain->sin_len = sizeof(struct sockaddr_in);
#endif
			sain->sin_addr.s_addr = ((struct sockaddr_in *)
			    res->ai_addr)->sin_addr.s_addr;
			sain->sin_port = lo->port;
			if (sain->sin_addr.s_addr == htonl(INADDR_LOOPBACK))
				h->local = 1;
		} else {
			sin6 = (struct sockaddr_in6 *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
			sin6->sin6_len = sizeof(struct sockaddr_in6);
#endif
			memcpy(&sin6->sin6_addr, &((struct sockaddr_in6 *)
			    res->ai_addr)->sin6_addr, sizeof(struct in6_addr));
			sin6->sin6_port = lo->port;
			if (IN6_IS_ADDR_LOOPBACK(&sin6->sin6_addr))
				h->local = 1;
		}

		config_listener(h, lo);

		cnt++;
	}

	freeaddrinfo(res0);
	return (cnt);
}

static int
interface(struct listen_opts *lo)
{
	struct ifaddrs *ifap, *p;
	struct sockaddr_in	*sain;
	struct sockaddr_in6	*sin6;
	struct listener		*h;
	int			ret = 0;

	if (getifaddrs(&ifap) == -1)
		fatal("getifaddrs");

	for (p = ifap; p != NULL; p = p->ifa_next) {
		if (p->ifa_addr == NULL)
			continue;
		if (strcmp(p->ifa_name, lo->ifx) != 0 &&
		    !is_if_in_group(p->ifa_name, lo->ifx))
			continue;
		if (lo->family != AF_UNSPEC && lo->family != p->ifa_addr->sa_family)
			continue;

		h = xcalloc(1, sizeof(*h));

		switch (p->ifa_addr->sa_family) {
		case AF_INET:
			sain = (struct sockaddr_in *)&h->ss;
			*sain = *(struct sockaddr_in *)p->ifa_addr;
#ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
			sain->sin_len = sizeof(struct sockaddr_in);
#endif
			sain->sin_port = lo->port;
			if (sain->sin_addr.s_addr == htonl(INADDR_LOOPBACK))
				h->local = 1;
			break;

		case AF_INET6:
			sin6 = (struct sockaddr_in6 *)&h->ss;
			*sin6 = *(struct sockaddr_in6 *)p->ifa_addr;
#ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
			sin6->sin6_len = sizeof(struct sockaddr_in6);
#endif
			sin6->sin6_port = lo->port;
			if (IN6_IS_ADDR_LOOPBACK(&sin6->sin6_addr))
				h->local = 1;
			break;

		default:
			free(h);
			continue;
		}

		config_listener(h, lo);
		ret = 1;
	}

	freeifaddrs(ifap);

	return ret;
}

int
delaytonum(char *str)
{
	unsigned int     factor;
	size_t           len;
	const char      *errstr = NULL;
	int              delay;

	/* we need at least 1 digit and 1 unit */
	len = strlen(str);
	if (len < 2)
		goto bad;

	switch(str[len - 1]) {

	case 's':
		factor = 1;
		break;

	case 'm':
		factor = 60;
		break;

	case 'h':
		factor = 60 * 60;
		break;

	case 'd':
		factor = 24 * 60 * 60;
		break;

	default:
		goto bad;
	}

	str[len - 1] = '\0';
	delay = strtonum(str, 1, INT_MAX / factor, &errstr);
	if (errstr)
		goto bad;

	return (delay * factor);

bad:
	return (-1);
}

int
is_if_in_group(const char *ifname, const char *groupname)
{
#ifdef HAVE_STRUCT_IFGROUPREQ
        unsigned int		 len;
        struct ifgroupreq        ifgr;
        struct ifg_req          *ifg;
	int			 s;
	int			 ret = 0;

	if ((s = socket(AF_INET, SOCK_DGRAM, 0)) < 0)
		err(1, "socket");

        memset(&ifgr, 0, sizeof(ifgr));
        if (strlcpy(ifgr.ifgr_name, ifname, IFNAMSIZ) >= IFNAMSIZ)
		errx(1, "interface name too large");

        if (ioctl(s, SIOCGIFGROUP, (caddr_t)&ifgr) == -1) {
                if (errno == EINVAL || errno == ENOTTY)
			goto end;
		err(1, "SIOCGIFGROUP");
        }

        len = ifgr.ifgr_len;
        ifgr.ifgr_groups = xcalloc(len/sizeof(struct ifg_req),
		sizeof(struct ifg_req));
        if (ioctl(s, SIOCGIFGROUP, (caddr_t)&ifgr) == -1)
                err(1, "SIOCGIFGROUP");

        ifg = ifgr.ifgr_groups;
        for (; ifg && len >= sizeof(struct ifg_req); ifg++) {
                len -= sizeof(struct ifg_req);
		if (strcmp(ifg->ifgrq_group, groupname) == 0) {
			ret = 1;
			break;
		}
        }
        free(ifgr.ifgr_groups);

end:
	close(s);
	return ret;
#else
	return (0);
#endif
}

static int
config_lo_filter(struct listen_opts *lo, char *filter_name) {
	if (lo->options & LO_FILTER) {
		yyerror("filter already specified");
		return -1;
	}
	lo->options |= LO_FILTER;
	lo->filtername = filter_name;

	return 0;
}

static int
config_lo_mask_source(struct listen_opts *lo) {
	if (lo->options & LO_MASKSOURCE) {
		yyerror("mask-source already specified");
		return -1;
	}
	lo->options |= LO_MASKSOURCE;
	lo->flags |= F_MASK_SOURCE;

	return 0;
}

